!=========================================================================
! Copyright (C) GemStone Systems, Inc. 1986-2009.  All Rights Reserved.
!
! $Id: AnsiMisc.gs 22222 2009-09-02 00:36:20Z stever $
!
! Things that we want to add to base classes that reference globals
! that don't exist at the time these methods would otherwise be loaded.
!
!=========================================================================

category: 'ANSI support'
classmethod: Exception
signal: messageText

	^ExceptionA signal: messageText.
%

category: 'ANSI support'
method: Exception
handler

	^(subtype isKindOf: ExceptionHandler)
		ifTrue:  [subtype]
		ifFalse: [nil].
%

category: 'Block Evaluation'
method: ExecutableBlock
on: selector do: action
	"Try to evaluate the receiver, and should an exception occur which is matched
	by selector (normally a class object which is a subclass of ExceptionA), 
	evaluate the <monadicBlock>, action, passing it the exception 
	instance as its argument."

	^ExceptionHandler new
		try: self
		on: selector
		do: action.
%
