!=========================================================================
! Copyright (C) GemStone Systems, Inc. 1986-2009.  All Rights Reserved.
!
! $Id: object2.gs 22222 2009-09-02 00:36:20Z stever $
!
! Methods from Object for which source will be stripped
! (no longer stripping any source)
!
! Superclass Hierarchy:
!   Object.
!
!=========================================================================
 
! do not remove methods

category: 'Private'
classmethod: Object
_strippedMethodSelectors
 
"Returns all the method selectors whose source will be stripped when the
 repository is built.  The result consists of two subarrays: the instance method
 selectors and the class method selectors."
 
" do not want subclasses to inherit this list "
self ~~ Object
  ifTrue: [
    ^ self _stripAllMethodSources
      ifTrue: [ self _allStrippedMethodSelectors ]
      ifFalse: [ self _noStrippedMethodSelectors ]
  ].
 
^ #( " instance methods "
    #( )
 
     " class methods "
    #( )
  )
%

